using Jypeli;
using Jypeli.Assets;
using Jypeli.Controls;
using Jypeli.Widgets;
using System;
using System.Collections.Generic;

namespace Sammakkopeli
{
    public class Sammakkopeli : PhysicsGame
    {
        Vector suunta;

        PhysicsObject sammakko;

        Timer hyppyLaskuri;
        Timer tarkastaLiike;

        int sammakkoTippuuKertoja = 8;
        bool onkoHypannut = false;

        double nopeusX = 0.0;
        double nopeusY = -800.0;

        public override void Begin()
        {
            AlustaKentta();
            AsetaOhjaimet();
            Keyboard.Listen(Key.Escape, ButtonState.Pressed, ConfirmExit, "Lopeta peli");
        }


        public void AsetaOhjaimet()
        {
            Keyboard.Listen(Key.Left, ButtonState.Down, AsetaNopeus, null, -1);
            Keyboard.Listen(Key.Left, ButtonState.Released, PysaytaSammakko, null);

            Keyboard.Listen(Key.Right, ButtonState.Down, AsetaNopeus, null, 1);
            Keyboard.Listen(Key.Right, ButtonState.Released, PysaytaSammakko, null);

            Keyboard.Listen(Key.Space, ButtonState.Pressed, SammakkoHyppaa, null);
        }


        void AsetaNopeus(int suunta)
        {
            nopeusX = suunta * 600.0;
        }


        void PysaytaSammakko()
        {
            nopeusX = 0.0;
        }


        public void AlustaKentta()
        {
            Level.BackgroundColor = Color.Black;
            LuoPelihahmo(0, 0);

            Level.CreateBottomBorder(0.0, true);

            hyppyLaskuri = new Timer();
            hyppyLaskuri.Interval = 0.05;
            hyppyLaskuri.Timeout += SammakkoTippuu;

            tarkastaLiike = new Timer();
            tarkastaLiike.Interval = 0.05;
            tarkastaLiike.Timeout += LiikutaPelihahmoa;
            tarkastaLiike.Start();
        }


        public void LuoPelihahmo(double x, double y)
        {
            sammakko = new PhysicsObject(40.0, 26.0);
            sammakko.Shape = Shape.Rectangle;
            sammakko.X = x;
            sammakko.Y = y;
            sammakko.Color = Color.Green;
            Add(sammakko);

            AddCollisionHandler(sammakko, KasitteleSammakonTormays);
        }



        public void LiikutaPelihahmoa()
        {
            suunta = new Vector(nopeusX, nopeusY);
            sammakko.Velocity = suunta;
        }


        public void SammakkoHyppaa()
        {
            if (onkoHypannut == false)
            {
                onkoHypannut = true;
                hyppyLaskuri.Start(16);
            }
        }


        void SammakkoTippuu()
        {
            sammakkoTippuuKertoja -= 1;
            if (sammakkoTippuuKertoja < -7)
            {
                nopeusY = -800.0;
                sammakkoTippuuKertoja = 8;
                return;
            }
            nopeusY = sammakkoTippuuKertoja * 100;
        }


        void KasitteleSammakonTormays(PhysicsObject tormaaja, PhysicsObject kohde)
        {
            onkoHypannut = false;
        }
    }
}